﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace Lab20ClientMultiThread
{
    class Program
    {
        public static void Main(string[] args)
        {
            for (int i = 0; i < 5; i++)
            {
                Console.WriteLine($"\nConnection #{i}\n");
                Connect("127.0.0.1", $"Hello World! #{i}");
            }
        }

        private static void Connect(string addr, string message)
        {
            try
            {
                int port = 9999;
                TcpClient client = new TcpClient(addr, port);

                // Convert message to ASCII, then to bytes
                byte[] data = Encoding.ASCII.GetBytes(message);
                NetworkStream stream = client.GetStream();

                stream.Write(data, 0, data.Length);
                Console.WriteLine($"Sent message: \"{message}\""); ;

                // Server response handling
                data = new byte[256];
                string response = String.Empty;
                int bytes = stream.Read(data, 0, data.Length);
                response = Encoding.ASCII.GetString(data, 0, bytes);
                Console.WriteLine($"Server responded: \"{response}\"");
                stream.Close();
                client.Close();
            }
            catch (SocketException exc)
            {
                Console.WriteLine($"Socket exception: {exc}");
            }
        }
    }
}
